#!/bin/sh

check_if_file_exists()
{
  C:Echo "Expected: $1 created"
  if [ -f "$1" ]; then
  C:Echo "Actual  : $1 created"
  else
  C:Echo "Actual  : $1 NOT CREATED"
  fi
}

delete_files_conf_aros()
{
  rm -f  ./Conf-Aros/config.log
  rm -f  ./Conf-Aros/config.status
  rm -f  ./Conf-Aros/Makefile
  rm -rf ./Conf-Aros/conf*.dir
  rm -rf ./Conf-Aros/bin
}

delete_files_conf_water()
{
  rm -f  ./Conf-Water/config.log
  rm -f  ./Conf-Water/config.status
  rm -f  ./Conf-Water/Makefile
  rm -f  ./Conf-Water/configure
  rm -f  ./Conf-Water/*.o
  rm -f  ./Conf-Water/water
  rm -rf ./Conf-Water/autom4te.cache
  rm -rf ./Conf-Water/conf*.dir
}


# TEST 1
delete_files_conf_aros

C:Echo "--configure test--"
cd Conf-Aros
./configure --target=pc-i386 2>&1 >NIL:
cd ..

check_if_file_exists "./Conf-Aros/Makefile"
echo "-----------------------------------"

delete_files_conf_aros




# TEST 2
delete_files_conf_water

C:Echo "--chain (autoconf/configure/make) test--"
cd Conf-Water
autoconf
./configure 2>&1 >NIL:
make 2>&1 >NIL:
cd ..

check_if_file_exists "./Conf-Water/configure"
check_if_file_exists "./Conf-Water/Makefile"
check_if_file_exists "./Conf-Water/water"

echo "-----------------------------------"

delete_files_conf_water

