#!/bin/sh
# Amiga/Unix paths are mixed up on purpose, both need to work!

/bin/rm -f main.o
/bin/rm -f main

C:Echo "--C compiler test--"
C:Echo "Expected: [C] Hello World <timestamp>"
C:Echo "Actual  : " NOLINE
/Development/bin/gcc -c /SYS/TestDevelopment/main.c -o SYS:TestDevelopment/main.o
/Development/bin/gcc /SYS/TestDevelopment/main.o -o main
/SYS/TestDevelopment/main
/Development/bin/rm main.o
/Development/bin/rm main
echo "-----------------------------------"

C:Echo "--C++ compiler test--"
C:Echo "Expected: [C++] Hello World <timestamp>"
C:Echo "Actual  : " NOLINE
/Development/bin/g++ -c /SYS/TestDevelopment/main.cpp -o main.o
/Development/bin/g++ SYS:TestDevelopment/main.o -o /SYS/TestDevelopment/main
SYS:TestDevelopment/main
/Development/bin/rm main.o
/Development/bin/rm /SYS/TestDevelopment/main
echo "-----------------------------------"

C:Echo "--C compiler test (/Development/bin)--"
C:Echo "Expected: [C] Hello World <timestamp>"
C:Echo "Actual  : " NOLINE
cd /Development/bin
gcc -c /SYS/TestDevelopment/main.c -o /SYS/TestDevelopment/main.o
gcc SYS:TestDevelopment/main.o -o SYS:TestDevelopment/main
/SYS/TestDevelopment/main
rm /SYS/TestDevelopment/main
rm SYS:TestDevelopment/main.o
cd /SYS/TestDevelopment
echo "-----------------------------------"

C:Echo "--C compiler test (pipe)--"
C:Echo "Expected: [C] Hello World <timestamp>"
C:Echo "Actual  : " NOLINE
cd Development:bin
gcc -pipe SYS:TestDevelopment/main.c -o /SYS/TestDevelopment/main
/SYS/TestDevelopment/main
cd /SYS/TestDevelopment
echo "-----------------------------------"

C:Echo "make test -> Expected: Make output and line '[C] Hello World <timestamp>'"
make clean
Development:bin/make
SYS:TestDevelopment/main
/Development/bin/make clean
echo "-----------------------------------"

rm -f main.o
rm -f main

