/* rx
**
** Sample ARexx script that loads a database, does a select-from-where
** query, prints the result and closes the database.
*/

options results

address MUIbase.1

handle = 0

connect "MUIbase:Demos/Movie.bbs"
if rc = 0 then
do
    handle = result
    eval handle 'select Title, Director from Movies'
end
select
    when rc = 0 then
        say result
    when rc = -1 then
        say "Implementation error"
    when rc = -2 then
        say "Out of memory"
    when rc = -3 then
        say "Unknown command"
    when rc = -4 then
        say "Command syntax error"
    when rc <= -10 then
        say lasterror
    otherwise
        say "Error:" rc
end

if handle > 0 then
    disconnect handle
