#!/bin/sh

Development:bin/rm -f main-pp.c
Development:bin/rm -f main-pp-2.c
Development:bin/rm -f main-pp.cpp
Development:bin/rm -f pattern_temp

C:Echo "grep test -> Expected: line '3:int main()' should be written"
Development:bin/grep -n main main.c
C:Echo "-----------------------------------"

C:Echo "cat test -> Expected: line 'Large brown snake' should be written"
Development:bin/cat Patterns/pattern_cat
C:Echo "-----------------------------------"

C:Echo "strip test -> Expected: no lines should be written"
Development:bin/strip --help > pattern_temp
diff -u pattern_temp Patterns/pattern_strip
C:Echo "-----------------------------------"

C:Echo "ls test -> Expected: no lines should be written"
Development:bin/ls Ls > pattern_temp
diff -u pattern_temp Patterns/pattern_ls
Development:bin/ls Ls -a > pattern_temp
diff -u pattern_temp Patterns/pattern_ls_a
C:Echo "-----------------------------------"

C:Echo "find test -> Expected: no lines should be written"
Development:bin/find Development:include -name mui*.h > pattern_temp
diff -u pattern_temp Patterns/pattern_find
C:Echo "-----------------------------------"

C:Echo "diff test -> Expected: no lines should be written"
Development:bin/gcc -E main.c -o main-pp.c
Development:bin/cp main-pp.c main-pp-2.c
Development:bin/diff main-pp.c main-pp-2.c
C:Echo "-----------------------------------"

C:Echo "tail test -> Expected: no lines should be written"
Development:bin/tail -n 15 Patterns/pattern_strip > pattern_temp
diff -u pattern_temp Patterns/pattern_tail
C:Echo "-----------------------------------"

Development:bin/rm -f main-pp.c
Development:bin/rm -f main-pp-2.c
Development:bin/rm -f main-pp.cpp
Development:bin/rm -f pattern_temp

